#include <stdlib.h>
#include <iostream.h>
#include <assert.h>
#include "prot-a-LyStr.h"
#include "question.h"
#include "connection.h"
#include "lookup_name_q.h"

    
lookup_name_question::lookup_name_question(Connection *conn,
					   const LyStr &template_str)
    : question(conn), matches()
{
    prot_a_LyStr   s;

    s << ref_no() << " 12 ";
    s.append_hollerith(template_str);
    s << '\n';
    port->send_question(s);
}


lookup_name_question::~lookup_name_question()
{
}


void
lookup_name_question::parser(prot_a_LyStr &str)
{
    int   arrsize;
    int   i;

    arrsize = str.parse_array_start();
    matches.set_size(arrsize);

    // Parse all Conf_nos first...
    for (i = 0; i < arrsize; ++i) 
	matches[i].parse_conf_no(str);
    str.parse_array_end(arrsize);

    // ...then parse all Conf_types.
    str.skipspace();
    if (str.strlen() == 0 || (arrsize > 0 && str[0] != '{')) {
	cerr << "lookup_name_question::parser(): protocol error\n";
	abort();
    } else
	str.remove_first(1);
    for (i = 0; i < arrsize; ++i) 
	matches[i].parse_conf_type(str);
    str.parse_array_end(arrsize);

    state = st_ok;
    deallocate_refno();
}


Array<Micro_conf>
lookup_name_question::result()
{
    return matches;
}
