#include <iostream.h>
#include <assert.h>
#include "prot-a-LyStr.h"
#include "question.h"
#include "connection.h"
#include "recipient.h"
#include "create_text_q.h"
    
create_text_question::create_text_question(Connection *conn,
					   const LyStr &message,
					   DLList<Recipient> recipients,
					   DLList<Text_no> comment_to,
					   DLList<Text_no> footnote_to)
    : question(conn), tno(0)
{
    Pix ix;
    prot_a_LyStr   s;
    int len = recipients.length() + comment_to.length() + footnote_to.length();

    s << ref_no() << " 28 ";
    s.append_hollerith(message);
    s << ' ' << len << " { ";
    for (ix = recipients.first(); ix != 0; recipients.next(ix))
	s << (recipients(ix).is_carbon_copy() ? "1 " : "0 ")
	    << recipients(ix).recipient() << ' ';

    for (ix = footnote_to.first(); ix != 0; footnote_to.next(ix))
	s << "4 " << footnote_to(ix) << ' ';

    for (ix = comment_to.first(); ix != 0; comment_to.next(ix))
	s << "2 " << comment_to(ix) << ' ';

    s << "}\n";

    port->send_question(s);
}


create_text_question::~create_text_question()
{
}


void
create_text_question::parser(prot_a_LyStr& str)
{
    tno = str.stol();
    state = st_ok;
    deallocate_refno();
}


Text_no
create_text_question::result()
{
    return tno;
}
