#include <iostream.h>
#include <assert.h>
#include "prot-a-LyStr.h"
#include "question.h"
#include "connection.h"
#include "set_client_version_q.h"

    
set_client_version_question::set_client_version_question(Connection *conn,
						   const LyStr &client_name,
						   const LyStr &client_version)
    : question(conn)
{
    if (conn->get_server_info()->get_version() >= 10400) 
    {
	prot_a_LyStr   s;

	s << ref_no() << " 69 ";
	s.append_hollerith(client_name);
	s << ' ';
	s.append_hollerith(client_version);
	s << '\n';
	port->send_question(s);
    }
    else 
    {
	// Pretend that everything went OK if we are connected to an
	// ancient server.
	state = st_ok;
	deallocate_refno();
    }
}


set_client_version_question::~set_client_version_question()
{
}


void
set_client_version_question::parser(prot_a_LyStr &str)
{
    state = st_ok;
    deallocate_refno();
}


void
set_client_version_question::result()
{
}
