#include <stdlib.h>
#include <iostream.h>
#include <assert.h>
#include "prot-a-LyStr.h"
#include "question.h"
#include "connection.h"
#include "mark_text_q.h"
#include "obsolete.h"		// for mark_text_old_question

    
mark_text_question::mark_text_question(Connection *conn,
				       Text_no text,
				       unsigned char mark_type)
    : question(conn), mark_text_old(NULL)
{
    prot_a_LyStr   s;

    if (conn->get_server_info()->get_version() >= 10400) {
	s << ref_no() << " 72 " << text << ' ' << int(mark_type) << '\n';
	port->send_question(s);
    } else {
	if (mark_type == 0) {
	    cerr << "Cannot mark with 0 on this server!\n";
            mark_type  = 1;	// +++Error handling
	}

	mark_text_old = new mark_text_old_question(conn, text, mark_type);
    }
}


mark_text_question::~mark_text_question()
{
    if (mark_text_old != NULL)
	delete mark_text_old;
}


Status 
mark_text_question::status()
{
    if (mark_text_old == NULL)
	return question::status();
    else
	return mark_text_old->status();
}


Status 
mark_text_question::receive()
{
    if (mark_text_old == NULL)
	return question::receive();
    else {
	deallocate_refno();
	return mark_text_old->receive();
    }
}


Kom_err
mark_text_question::error()
{
    if (mark_text_old == NULL)
	return question::error();
    else
	return mark_text_old->error();
}


void
mark_text_question::parser(prot_a_LyStr& str)
{
    state = st_ok;
    deallocate_refno();
}


void
mark_text_question::result()
{
    return;
}
