#ifndef QUESTION__
#define QUESTION__

#include "misc.h"
#include "error-codes.h"

class prot_a_LyStr;
class Ref_no;
class Connection;

// Send questions to LysKOM server

// Some things that are common to all different types of questions.
class question {
  public:
    question(Connection *conn);	// Allocates ref_no. The ref_no is
				// destructed when the reply comes.
    virtual ~question();	// Destructor.
    virtual  Status status();	// What is the status of this question?
    virtual  Status receive();	// Wait for reply.
    virtual  Kom_err error();	// The error code. Only 
				// valid if status() == error.
    virtual void parser(prot_a_LyStr &str) =0;
    void receive_err(int err);	// Deallocates ref_no.
  protected:
    Status state;		// Updated by all parsers.
    void deallocate_refno();	// Should be called from all
				// parser()s.
    Connection *port;
    int ref_no() const;
  private:
    Kom_err errcode;
    Ref_no *refno;
};

#endif
