#ifndef LyStr__
#define LyStr__

#include <iostream.h>
#include <limits.h>

class Connection;

// A simple string package. Why is libg++ so limited?
class LyStr {
  public:
    LyStr();
    LyStr(const char *c_str);
    LyStr(void *block, int len);
    LyStr(const LyStr &);
    ~LyStr();
    LyStr & operator = (const LyStr &);

    // operator << (...)  appends to the string
    LyStr &operator << (const LyStr &str);
    LyStr &operator << (char c);
    LyStr &operator << (long num); // Append decimal number
    void append(const char *buffer, long length);
    char & operator [] (long index);
    long strlen() const;
    void clear();
    void remove_first(long no);	// Remove first NO chars from the string.
    void remove_last(long no);	// Remove last NO chars from the string.
    void skipspace();		// Remove leading whitespace

    // Create a malloc'd copy of the string. If start and length are
    // given, a substring starting at start and length characters long
    // is returned. The malloced copy is always nul-terminated. The
    // nul is not counted in length.
    char *malloc_copy(long start=0, long length=LONG_MAX) const;

    // Create a new string, consisting of the first SIZE characters
    // from the string.
    LyStr substr(long size) const;

    friend ostream &operator <<(ostream &, const LyStr &);

  protected:
    char *data;			// size chars big
    long size;
    long used;			// Number of chars used.
    long origin;		// First char used.
};
#endif
