#ifndef ARRAY__
#define ARRAY__

#include <stream.h>

template <class T>
class Array {
  private:
    long   len;
    T    * arr;

  public:
    Array(long size = 0);
    Array(const Array &a);
    ~Array();

    const Array & operator = (const Array &a);

    void set_size(long size);

    long size() const;
    T &operator[](long i) const;
    void set(long i, T t);

    // friends:
    friend ostream &operator <<(ostream &str, const Array<T> &a);
};

#ifndef OUTLINE
#include "array.icc"
#endif

#endif  // ARRAY__
