#ifndef CONF_CACHE__
#define CONF_CACHE__

#include "kom-types.h"
#include "misc.h"
#include "conf-stat.h"
#include "Conf_no.Conf_stat.CHMap.h"
#include "Conf_no.get_conf_stat_question_ptr.CHMap.h"


class Conf_cache {
  public:
    Conf_cache(Connection *c);
    Conf_cache(const Conf_cache&);
    Conf_cache& operator=(const Conf_cache&);
    ~Conf_cache();

    // Methods working on the entire cache:
    Connection *connection() const;
    Bool        present(Conf_no cno) const;
    void        clear();

    // Methods working on individual conf-stats.
    Status      prefetch(Conf_no cno);
    Conf_stat   get(Conf_no cno);
    void        remove(Conf_no cno);

  private:
    class Ccmap : private Conf_noConf_statCHMap {
      public:
	Bool present(Conf_no c) const;
	Conf_stat &operator[](Conf_no c);
	Ccmap();
    };

    class Ccreqmap : private Conf_noget_conf_stat_question_ptrCHMap {
      public:
    	Bool present(Conf_no c);
    	void delete_entry(Conf_no c);
    	get_conf_stat_question *&operator[](Conf_no c);
    	Ccreqmap();
    };

    Connection* conn;
    Ccmap       statusmap;
    Ccreqmap    pendingmap;
};

#endif
