#ifndef CONF_STAT__
#define CONF_STAT__

#include <time.h>

#include "conf-type.h"
#include "kom-types.h"
#include "misc.h"
#include "LyStr.h"

class prot_a_LyStr;

class Conf_stat {
  public:
    Conf_stat();
    Conf_stat(const Conf_stat &conf_stat);
    Conf_stat(Conf_no conf_no, prot_a_LyStr &prot_a_str);
    Conf_stat(int errno);
    ~Conf_stat();
    Conf_stat &operator=(const Conf_stat &);

    Bool  valid() const;
    int   errno() const;

    Pers_no	        creator() 	       const;
    struct tm		creation_time()        const;
    Text_no	        presentation() 	       const;
    Conf_no	        supervisor() 	       const;
    Conf_no	        permitted_submitters() const;
    Conf_no	        super_conf() 	       const;
    Conf_type	 	type() 		       const;
    struct tm	        last_written() 	       const;
    Text_no	        msg_of_day() 	       const;
    Garb_nice	        nice() 		       const;
    LyStr		name() 		       const;
    unsigned short	no_of_members()        const;
    Local_text_no	first_local_no()       const;
    unsigned long	no_of_texts() 	       const;

  private:
    struct Conf_stat_internal {
      public:
	Conf_stat_internal();
	Conf_stat_internal(Conf_no conf_no, prot_a_LyStr &prot_a_str);
	Conf_stat_internal(const Conf_stat_internal &);
	const Conf_stat_internal &operator =(const Conf_stat_internal &);

	int     refcount;
	Conf_no	this_conf_no;
	int     kom_errno;

	Pers_no	        creator;
	struct tm	creation_time;
	Text_no	        presentation;
	Conf_no	        supervisor;
	Conf_no	        permitted_submitters;
	Conf_no	        super_conf;
	Conf_type	type;
	struct tm	last_written;
	Text_no	        msg_of_day;
	Garb_nice	nice;
	LyStr		conf_name;
	unsigned short	no_of_members;
	Local_text_no	first_local_no;
	unsigned long	no_of_texts;
    };

    Conf_stat_internal  * csi;
};

#endif
