#ifndef CONF_TYPE__
#define CONF_TYPE__

#include "misc.h"
#include "prot-a-LyStr.h"

class prot_a_LyStr;

class Conf_type {
 public:
    friend Conf_type parse_conf_type(prot_a_LyStr &);

    Conf_type();
    Conf_type(const Conf_type&);
    Conf_type(Bool protect,
	      Bool orig,
	      Bool secr,
	      Bool letterbox);

    Conf_type &operator =(const Conf_type &);

    Bool is_protected() const;
    Bool is_original()  const;
    Bool is_secret()    const;
    Bool is_letterbox() const;

 private:
    Bool rd_prot;
    Bool original;
    Bool secret;
    Bool letter_box;
};

Conf_type parse_conf_type(prot_a_LyStr &prot_a_str);
#endif
