#include <assert.h>
#include "conference.h"
#include "maps.h"
#include "connection.h"
#include "map-cache.h"

Maps::Maps()
  : cache(NULL)
{
}

Maps::Maps(const Conferences&c)
  : cache(new Map_cache(c))
{
}

Maps::~Maps()
{
}

Maps & 
Maps::operator = (const Maps &m)
{
    cache = m.cache;
    return *this;
}

void
Maps::set_conferences(const Conferences&c)
{
    assert(cache == NULL);
    cache = new Map_cache(c);
}

Connection *
Maps::connection() const
{
    return cache->connection();
}

    
Text_mapping
Maps::operator[](Conf_no c) const
{
    return cache->get(c);
}

Map_cache *
Maps::read_map_cache() const
{
    return cache;
}
