#ifndef MEMBERSHIP__
#define MEMBERSHIP__

#include <DLList.h>
#include <time.h>

#include "misc.h"
#include "kom-types.h"

class prot_a_LyStr;


/*  Information about a person's membership in a conference  */
class Membership {
 public:
    Membership();
    Membership(const Membership&);
    Membership(prot_a_LyStr &prot_a_str);
    const Membership &operator =(const Membership &);

    Conf_no        conf_no() const;
    int            placement() const;
    unsigned char  priority() const;
    struct tm      last_time_read() const;
    
    Bool           is_read(Local_text_no)   const;
    Local_text_no  last_text_read()         const;
    long	   num_read_after_last_text_read() const;
 private:
    Conf_no		m_conf_no;
    unsigned char	m_priority; // Interrupt priority
    struct tm	m_last_time_read;   // Updated every time a text in this
                                    // conf. is marked as read.
    Local_text_no	m_last_text_read; // All texts before and
                                          // inclusive this are read 
    DLList<Local_text_no> read_texts; // Texts after last_text_read.
				      // Sorted in ascending order. 
};
#endif
