#ifndef PERS_CACHE__
#define PERS_CACHE__

#include "kom-types.h"
#include "misc.h"
#include "pers-stat.h"
#include "Pers_no.Pers_stat.CHMap.h"
#include "Pers_no.get_person_stat_question_ptr.CHMap.h"


class Pers_cache {
  public:
    Pers_cache(Connection *c);
    Pers_cache(const Pers_cache&);
    Pers_cache& operator=(const Pers_cache&);
    ~Pers_cache();

    // Methods working on the entire cache:
    Bool        present(Pers_no pno) const;
    void        clear();

    // Methods working on individual pers-stats.
    Status      prefetch(Pers_no pno);
    Pers_stat   get(Pers_no pno);
    void        remove(Pers_no pno);

  private:
    class Ppmap : private Pers_noPers_statCHMap {
      public:
	Bool present(Pers_no p) const;
	Pers_stat &operator[](Pers_no p);
	Ppmap();
    };

    class Ppreqmap : private Pers_noget_person_stat_question_ptrCHMap {
      public:
    	Bool present(Pers_no p);
    	void delete_entry(Pers_no p);
    	get_person_stat_question *&operator[](Pers_no p);
    	Ppreqmap();
    };

    Connection* conn;
    Ppmap       statusmap;
    Ppreqmap    pendingmap;
};

#endif
