#ifndef PERSONAL_FLAGS__
#define PERSONAL_FLAGS__

#include "misc.h"

class LyStr;

/*
 * Flags in the Person struct.
 */
class Personal_flags {
  public:
    Personal_flags();
    Personal_flags(const Personal_flags&);

    const Personal_flags &operator =(const Personal_flags&);

    friend Personal_flags parse_personal_flags(LyStr &prot_a_str);

    Bool unread_is_secret() const;
  private:
   /* FALSE if everyone is allowed to ask how 
    many unread texts you have.	*/
    unsigned int  pf_unread_is_secret : 1;
    unsigned int  flg2	: 1;
    unsigned int  flg3	: 1;
    unsigned int  flg4	: 1;
    unsigned int  flg5	: 1;
    unsigned int  flg6	: 1;
    unsigned int  flg7	: 1;
    unsigned int  flg8	: 1;
};

Personal_flags parse_personal_flags(LyStr &prot_a_str);
#endif
