#include <assert.h>
#include <ctype.h>
#include "prot-a-LyStr.h"

prot_a_LyStr::prot_a_LyStr() 
{ 
}

prot_a_LyStr::prot_a_LyStr(const char *c_str)
    : LyStr(c_str)
{
}

prot_a_LyStr::prot_a_LyStr(void *block, int len)
    : LyStr(block, len)
{
}

prot_a_LyStr::prot_a_LyStr(const prot_a_LyStr &l)
    : LyStr(l)
{
}

prot_a_LyStr::prot_a_LyStr(const LyStr &l)
    : LyStr(l)
{
}


// ================================================================


long
prot_a_LyStr::stol()
{
    // +++ Better error handling needed here.
    long res = 0;
    int i = 0;

    while (i < used && operator[](i) == ' ')
	i++;

    while(i < used && isdigit(operator[](i)))
    {
	res *= 10;
	res += operator[](i++) - '0';
    }

    remove_first(i);
    return res;
}

LyStr
prot_a_LyStr::stos()
{
    long len = stol();
    assert (operator[](0) == 'H');
    remove_first(1);
    LyStr res = substr(len);
    remove_first(len);
    return res;
}

void
prot_a_LyStr::append_hollerith(const LyStr &str)
{
    *this << str.strlen() << 'H' << str;
}


int
prot_a_LyStr::parse_array_start()
{
    int   size;

    size = stol();
    if (size > 0)
    {
	skipspace();
	if (strlen() > 0 && operator[](0) == '{')
	    remove_first(1);
    }
    
    return size;
}


void
prot_a_LyStr::parse_array_end(int arrsize)
{
    skipspace();
    if (arrsize < 0)
	return;
    else if (arrsize == 0) {
	if (strlen() > 0) {
	    if (operator[](0) == '*')
		remove_first(1);
	}
    } else {
	if (strlen() > 0) {
	    if (operator[](0) == '}')
		remove_first(1);
	}
    }
}


void
prot_a_LyStr::append_array_start(int arrsize)
{
    *this << arrsize << " {";
}


void
prot_a_LyStr::append_array_end()
{
    *this <<  "} ";
}
