#ifndef Session__
#define Session__

#include <stdlib.h>
#include <iostream.h>

#include "array.h"
#include "LyStr.h"
#include "kom-types.h"
#include "micro-conf.h"
#include "connection.h"
#include "mark.h"

#include "conference.h"
#include "person.h"
#include "maps.h"
#include "text.h"
//#include "memberships.h"   // +++NYI


// +++FIXME: Hur skall felhanteringen g} till?  Vi vill kunna f} ut
//           en felkod om n}got g}r fel.

class Session {
  public:
    Session(Connection * = NULL);
    Session(const Session &);
    ~Session();

    const Session & operator = (const Session &);

    friend ostream &operator <<(ostream &, const Session &);

    void       set_connection(Connection *);

    Conferences &  conferences();
    Persons     &  persons();
    Maps        &  maps();
    Texts       &  texts();

    Status     login(Pers_no, LyStr &, Bool invisible = FALSE);
    struct tm  get_time(); 
    Array<Micro_conf>   lookup_name(const LyStr &pattern);
    Array<Pers_no>      regexp_lookup_persons(const LyStr &pattern);
    Array<Mark>         get_marks();

  private:
    Connection  * conn;

    Conferences * all_confs;
    Persons     * all_persons;
    Maps        * all_maps;
    Texts       * all_texts;
    
};
#endif  // Session__
