#ifndef TEXT_CACHE__
#define TEXT_CACHE__

#include "kom-types.h"
#include "misc.h"
#include "text-stat.h"
#include "Text_no.Text_stat.CHMap.h"
#include "Text_no.get_text_stat_question_ptr.CHMap.h"

class Connection;

class Text_stat_cache {
  public:
    Text_stat_cache(Connection *c);
    Text_stat_cache(const Text_stat_cache&);
    Text_stat_cache& operator=(const Text_stat_cache&);
    ~Text_stat_cache();

    // Methods working on the entire cache:
    Bool        present(Text_no tno) const;
    void        clear();
    Connection *connection() const;

    // Methods working on individual text-stats.
    Status      prefetch(Text_no tno);
    Text_stat   get(Text_no tno);
    void        remove(Text_no tno);

  private:
    class Tstmap : private Text_noText_statCHMap {
      public:
	Bool present(Text_no p) const;
	Text_stat &operator[](Text_no p);
	Tstmap();
    };

    class Tstreqmap : private Text_noget_text_stat_question_ptrCHMap {
      public:
    	Bool present(Text_no p);
    	void delete_entry(Text_no p);
    	get_text_stat_question *&operator[](Text_no p);
    	Tstreqmap();
    };

    Connection* conn;
    Tstmap      statusmap;
    Tstreqmap   pendingmap;
};

#endif
