#ifndef TEXT_STAT__
#define TEXT_STAT__

#include <time.h>
#include <DLList.h>

#include "array.h"
#include "kom-types.h"
#include "recipient.h"

class Uplink;
class prot_a_LyStr;

/*  Struct for text status  */
class Text_stat {
  public:
    Text_stat();
    Text_stat(const Text_stat&);
    Text_stat(Text_no tno, prot_a_LyStr &prot_a_string);
    Text_stat(int errno);
    Text_stat &operator =(const Text_stat &);
    ~Text_stat();

    Bool 	valid() 	 const;
    int         errno()          const;

    Text_no     text_no()        const;
    struct tm   creation_time()  const;
    Pers_no     author()         const;
    long        length()         const;
    int         num_marks()      const;
    int         num_recipients() const;
    Recipient*  recipient(int)   const;
    int		num_comment_in() const;
    Text_no	comment_in(int)	 const;
    int		num_footnote_in()const;
    Text_no	footnote_in(int) const;
    int		num_uplinks()	 const;
    Uplink*	uplink(int)	 const;
  private:
    struct Text_stat_internal {
      public:
	Text_stat_internal();
	Text_stat_internal(Text_no text_no, prot_a_LyStr &prot_a_str);
	Text_stat_internal(const Text_stat_internal &);
	const Text_stat_internal &operator =(const Text_stat_internal &);

	int refcount;
	int kom_errno;

	Text_no           number;
	struct tm	  ctime;
	Pers_no		  auth;	
	unsigned short	  no_of_lines;
	unsigned long  	  no_of_chars;
	unsigned short	  no_of_marks;	
	Array<Recipient*> recipients; // ...and cc_recipients
	Array<Text_no>	  comments_in;
	Array<Text_no>	  footnotes_in;
	Array<Uplink*>	  uplinks; // footn_to, comm_to
    };
    check_tsi() const;
    Text_stat_internal *tsi;
};
#endif
