#ifndef UPLINK__
#define UPLINK__

#include <time.h>

#include "kom-types.h"
#include "misc.h"

class prot_a_LyStr;

class Uplink {
  public:
    Uplink();
    Uplink(const Uplink&);
    const Uplink &operator =(const Uplink &);

    int parse(Bool is_footnote, prot_a_LyStr &prot_a_str);

    Bool      is_footnote()const;
    Text_no   parent()     const;
    Pers_no   sender()     const;
    Bool      sent_later() const;
    struct tm sent_at()    const;
  private:
    enum { FOOTNOTE, COMMENT } upl_link_type;
    Text_no	upl_parent_text_no;
    Pers_no	upl_sender;	// 0 if not sent. Always 0 for FOOTNOTEs.
    Bool	upl_sent_later;
    struct tm	upl_sent_at;	// Only valid if sent_later is true.
};
#endif
