#include <stdlib.h>
#include "who-info.h"
#include "prot-a-LyStr.h"


Who_info::Who_info()
: person(0), what_am_i_doing(),username(), 
    working_conference(0), session_no(0)
{
}


Who_info::Who_info(const Who_info &w)
: person(w.person), what_am_i_doing(w.what_am_i_doing),
    username(w.username), working_conference(w.working_conference),
    session_no(w.session_no)
{
}


Who_info::Who_info(prot_a_LyStr &prot_a_string)
{
    parse(prot_a_string);
}


Who_info &
Who_info::operator =(const Who_info &w)
{
    person = w.person;
    what_am_i_doing = w.what_am_i_doing;
    username = w.username;
    working_conference = w.working_conference;
    session_no = w.session_no;

    return *this;
}


void
Who_info::parse(prot_a_LyStr &prot_a_string)
{
    person = prot_a_string.stol();
    working_conference = prot_a_string.stol();
    session_no = prot_a_string.stol();
    what_am_i_doing = prot_a_string.stos();
    username = prot_a_string.stos();
}


Session_no
Who_info::session() const
{
    return session_no;
}


Pers_no
Who_info::pers_no() const
{
    return person;
}


Conf_no
Who_info::working_conf() const
{
    return working_conference;
}
