#include <stdlib.h>
#include <iostream.h>
#include "prot-a-LyStr.h"
#include "connection.h"
#include "login_q.h"
#include "get_text_q.h"
#include "prot-a-LyStr.h"
#include "async.h"

Connection *port = NULL;
Async_storage *async_store = NULL;

void async_login(prot_a_LyStr args)
{
    cout << "\nAsync login msg: " << args;
}


int 
main(int argc,
     char **argv)
{
    port = new Connection("kom.lysator.liu.se", "lyskom");
    async_store = new Async_storage(port);
#if 0
    port->install_async_parser(ASYNC_LOGIN, async_login);
#endif

    login_question in(port, 90, "gazonk");
    get_text_question te(port, 4711, 0, 10000);

    if (in.receive() != st_ok)
    {
	cerr << "Login error " << in.error() << "\n";
	exit(1);
    }

    if (te.receive() != st_ok)
    {
	cerr << "get-text error " << te.error() << "\n";
	exit(1);
    }

    cout << te.result();

    while (async_store->handle_async() == st_pending)
    {
	if (Connection::drain(1000) == st_error)
	{
	    cerr << "Connection lost." << endl;
	    exit(1);
	}
    }    

    delete port;
    exit(0);
}
