proc usage {{exitstatus 0}} {
    puts {Anvndning: tkom [server-adress [portnummer]]}
    exit $exitstatus
}


proc tkerror {dummy} {
    global errorInfo
    puts $errorInfo
    puts $dummy
}

proc stress {} {while 1 {default_action ;update}}

if {[lsearch [info vars] tk_library] == -1} {
    set tk_library /usr/local/lib/tk
    puts "tk_library reset to /usr/local/lib/tk"
}

#source $tk_library/wish.tcl
source $tk_library/button.tcl
source $tk_library/entry.tcl
source $tk_library/menu.tcl
source $tk_library/text.tcl
source $tk_library/tk.tcl

source $kom_library/komlib.tcl
source $kom_library/tkom_main_window.tcl

# ================================================================
#             Require and Provide, just like in elisp


set loaded_packages {}

proc require {package} {
    global loaded_packages
    global kom_library

    if {[lsearch $loaded_packages $package]==-1} {
	uplevel #0 source $kom_library/$package.tcl
    } 
}

proc provide {package} {
    global loaded_packages

    lappend loaded_packages $package
}


# ================================================================

set romanfont {*-Courier-Medium-R-Normal-*-120-*}
set boldfont  {*-Courier-Bold-R-Normal-*-120-*}

# ================================================================


# Construct the main window and wait for it to show up on the screen.
main_window
focus default .
tkwait visibility .mesgf.message

# Init global variables and show current status.
set this_person 0
set to_mark_as_read {}
set current_text  0
set current_conf -2
show_current_conf $current_conf
update


# ================================================================
# Support for kom operations when testing without a real server:


if {[info commands kom_text] == ""} {
    source $kom_library/kom_support.tcl
}


# ================================================================
#              Now it's time to get things started...


#
# 1. Connect to the KOM server
#
set KOM_SERVER kom.lysator.liu.se
set KOM_PORT 4894
if {$argc > 0} {set KOM_SERVER [lindex $argv 0]}
if {$argc > 1} {set KOM_PORT [lindex $argv 1]}
if {$argc > 2} {usage 1}

show_message "Kopplar upp mot $KOM_SERVER..."
update
connect $KOM_SERVER $KOM_PORT
show_message "klart.\n"
kom_session set_client_version tkom 0.1

set current_conf -1
show_current_conf $current_conf
update

#
# 2. Log in
#
set komrcname [format "%s/.komrc" $env(HOME)]
if {[file exists $komrcname]} {
    set komfile [open $komrcname r]
    gets $komfile persno
    gets $komfile passwd
    
    show_message "Loggar in som [kom_conference name $persno]..."
    update
    if {[kom_session login $persno $passwd]} {
        show_message "klart.\n"
        set this_person $persno
        set current_conf 0
        show_current_conf $current_conf
    } else {
        show_message "det gick inte.\n"
    }
} else {
    require tkom_commands_session
    login
}
set passwd ""

#
# 3. Do some things, such as show the default action, before we give 
#    the control to the user.
#
do_things_before_waiting
