provide tkom_commands_read


# ================================================================


proc show_unread {} {
    #
    # Brja med att prefetcha den information vi behver
    #
    set unread_confs [llength [kom_unread unread_texts]]
    set prefetch_calls 0
    while {[kom_unread prefetch_map 0 20 $unread_confs 40 0] > 0} {
        if {$prefetch_calls == 0} {
            show_message "Jag mste hmta lite information frn servern\n"
            show_message "Vnta ett tag.."
        }
        show_message "."
	update
	incr prefetch_calls 1
    }
    if {$prefetch_calls > 0} {
        show_message "klart\n"
    }
    kom_unread prefetch_map 0 0 0 10 10

    #
    # Nu kan vi visa hur mnga olsta vi har.
    #
    set mintotal 0
    set maxtotal 0
    show_message "Du har olsta inlgg i fljande mten:\n"
    foreach conf [kom_unread unread_texts] {
        set confno [lindex $conf 0]
        set min    [lindex $conf 1]
        set max    [lindex $conf 2]

	if {$max == $min} {
	    if {$max > 0} {
                show_message [format "     %6d %s\n" $min \
                                [kom_conference name $confno]]
            }
	} else {
                show_message [format "%4d-%6d %s\n" $min $max \
                                [kom_conference name $confno]]
	}
	incr mintotal $min
        incr maxtotal $max
    }
    if {$mintotal == $maxtotal} {
        show_message "\nTotalt $mintotal olsta\n\n"
    } else {
        show_message "\nTotalt mellan $mintotal och $maxtotal olsta\n"
    }
}


# ================================================================
#                    The goto conference command


# This variable is 1 when there are alternatives to choose from
# in the listbox 'conflist'.
set conflist_contains_confs   0


proc goto_conf_window {w} {
    global romanfont
    global boldfont

    require tkom_windows

    toplevel $w 
    wm title $w "G till mte"

    # The selector frame
    frame $w.top 
    pack $w.top -side top -fill both
    listbox $w.top.conflist -relief raised -setgrid true \
	-yscrollcommand "$w.top.listscroll set"
    scrollbar $w.top.listscroll -relief flat -command "$w.top.conflist yview"
    pack $w.top.conflist -side left -expand TRUE -fill both
    pack $w.top.listscroll -side right -fill y

    frame $w.fr -relief raised -bd 2
    pack $w.fr -side top -fill both
    label $w.fr.conflbl -font $boldfont -text "Mte: "
    entry $w.fr.confentry -font $romanfont
    pack $w.fr.conflbl $w.fr.confentry -side left

    ok_cancel_buttons $w "Vlj"
    bind $w.top.conflist <Double-1>  "goto_conf_click_on_conf $w %y"
}


proc goto_conf_click_on_conf {w y} {
    global conflist_contains_confs

    if {$conflist_contains_confs} {
        $w.fr.confentry delete 0 end
        $w.fr.confentry insert 0 [$w.top.conflist get \
				      [$w.top.conflist nearest $y]]
    }
}


proc goto_conf {{conf {}}} {
    global conflist_contains_confs
    global passwd_string

    goto_conf_window .goto_conf
    if {$conf != ""} {
        .goto_conf.fr.confentry insert end $conf
    }
    set conflist_contains_confs 0

    while {1} {
        if {[wait_for_window .goto_conf .goto_conf.fr.confentry] == "ok"} {
            set conf_to_go_to [.goto_conf.fr.confentry get]
            set matches [kom_session lookup_name $conf_to_go_to]
            .goto_conf.top.conflist delete 0 end

            set conflist_contains_confs 0
            if {[llength $matches] == 0} {
                .goto_conf.top.conflist delete 0 end
                .goto_conf.top.conflist insert end "Ingen trff p namnet"
                set conflist_contains_confs 0

            } elseif {[llength $matches] == 1} {
                # Only 1 conf matched ==> Try to go there.
                set confno [micro-conf confno [lindex $matches 0]]

                if {[safe_eval {kom_unread goto_conf $confno; format TRUE} \
			       {{{KOM} {return FALSE}}}]} \
		{
		    show_current_conf $confno
                    set current_conf  $confno
                    destroy .goto_conf
                    do_things_before_waiting
                    return
                } else {
                    .goto_conf.top.conflist delete 0 end
                    .goto_conf.top.conflist insert end "Du fick inte g dit."
                    set conflist_contains_confs 0
                }

            } elseif {[llength $matches] > 1} {
                set i 0
                while {$i < [llength $matches]} {
                    set match [lindex $matches $i]
                    if {![micro-conf is-letterbox $match]} {
                        .goto_conf.top.conflist insert end \
			    [kom_conference name [micro-conf confno $match]]
                    }
                    incr i
                }
                set conflist_contains_confs 1
            }
        } else {
            destroy .goto_conf
            return
        }
    }
}
