provide tkom_commands_session


# ================================================================
#                         The login command


# This variable is 1 when there are alternatives to choose from
# in the listbox 'namelist'.
set namelist_contains_names   0
set passwd_string {}


proc login_window {w} {
    global romanfont
    global boldfont
    global passwd_string

    require tkom_windows

    toplevel $w 
    wm title $w "tkom login"

    listbox $w.namelist -bd 2 -setgrid true
    pack $w.namelist -side top -fill both

    frame $w.fr1 -relief raised -bd 2
    pack $w.fr1 -side top -fill both
    label $w.fr1.namelbl -font $boldfont -text "Namn:  "
    entry $w.fr1.nameentry -font $romanfont
    pack $w.fr1.namelbl $w.fr1.nameentry -side left

    frame $w.fr2 -relief raised -bd 2
    pack $w.fr2 -side top -fill both
    label $w.fr2.passwlbl -font $boldfont -text "Lsen: "
    entry $w.fr2.passwentry -font $romanfont
    pack $w.fr2.passwlbl $w.fr2.passwentry -side left
    bind $w.fr2.passwentry <Control-KeyPress> "handle_passwd $w.fr2.passwentry %A"
    bind $w.fr2.passwentry <KeyPress>         "handle_passwd $w.fr2.passwentry %A"
    set passwd_string {}

    ok_cancel_buttons $w "Logga in"
    bind $w.namelist <Double-1>  "login_click_on_name $w %y"
}

proc handle_passwd {w key} {
    global passwd_string 
    
    if {[string match "\r" $key]} {
        # <Return>
        #puts "The password is $passwd_string"
        return

    } elseif {[string match "\010" $key] || [string match "\177" $key]} {
        # <Delete> or <Back space>
        set passwd_string [string range $passwd_string 0 \
             [expr [string length $passwd_string]-2]]
        $w delete 0 0
        return

    } elseif {[string match "\025" $key]} {
        # Control-u
        set passwd_string {}
        $w delete 0 end
        return

    } elseif {[string match "\t" $key]} {
        # <Tab>
        puts "You pressed <tab>"; return
    }
 
    if {[string compare $key " "] > 0} {
        set passwd_string "$passwd_string$key"
        $w insert end #
    } 
}

proc login_click_on_name {w y} {
    global namelist_contains_names

    if {$namelist_contains_names} {
        $w.fr1.nameentry delete 0 end
        $w.fr1.nameentry insert 0 [$w.namelist get [$w.namelist nearest $y]]
    }
}


proc login {{name {}} {password {}}} {
    global namelist_contains_names
    global passwd_string

    login_window .login
    if {$name != ""} {
        .login.fr1.nameentry insert end $name
    }
    set namelist_contains_names 0

    while {1} {
        if {[wait_for_window .login .login.fr1.nameentry] == "ok"} {
            set loginname [.login.fr1.nameentry get]
            set matches [kom_session lookup_name $loginname]
            .login.namelist delete 0 end

            set namelist_contains_names 0
            if {[llength $matches] == 0} {
                .login.namelist delete 0 end
                .login.namelist insert end "Ingen trff p namnet"
                set namelist_contains_names 0

            } elseif {[llength $matches] == 1} {
                # Only 1 name matched ==> Try to log in.
                set persno [micro-conf confno [lindex $matches 0]]
                if {[kom_session login $persno $passwd_string]} {
                    global this_person
                    global current_conf

                    set this_person $persno
                    show_message "Du r nu inloggad som [kom_conference name $persno]\n"
                    set current_conf 0
                    destroy .login
                    do_things_before_waiting
                    return
                } else {
                    .login.namelist delete 0 end
                    .login.namelist insert end "Felaktigt lsenord"
                    set namelist_contains_names 0
                }

            } elseif {[llength $matches] > 1} {
                set i 0
                while {$i < [llength $matches]} {
                    set match [lindex $matches $i]
                    if {[micro-conf is-letterbox $match]} {
                        .login.namelist insert end [kom_conference name \
                               [micro-conf confno $match]]
                    }
                    incr i
                }
                set namelist_contains_names 1
            }
        } else {
            show_message "Inloggningen avbruten!\n"
            destroy .login
            return
        }
    }
}
