provide tkom_commands_text


# ================================================================
#                         The mark command


proc mark_window {w} {
    global romanfont
    global boldfont

    require tkom_windows

    toplevel $w 
    wm title $w "markera text"

    frame $w.fr1 -relief raised -bd 2
    pack $w.fr1 -side top -fill both
    label $w.fr1.textnolbl -font $boldfont -text "Text nummer:       "
    entry $w.fr1.textno_entry -font $romanfont
    pack $w.fr1.textnolbl $w.fr1.textno_entry -side left

    frame $w.fr2 -relief raised -bd 2
    pack $w.fr2 -side top -fill both
    label $w.fr2.marklbl -font $boldfont -text   "Markering (1-255): "
    entry $w.fr2.mark_entry -font $romanfont
    pack $w.fr2.marklbl $w.fr2.mark_entry -side left

    ok_cancel_buttons $w "Markera"
}


proc mark_command {{textno {}} {mark {}}} {
    mark_window .mark
    if {$textno != ""} {
        .mark.fr1.textno_entry insert end $textno
    }
    if {$mark == ""} {
        .mark.fr2.mark_entry insert end 255
    } else {
        .mark.fr2.mark_entry insert end $mark
    }

    while {1} {
        if {[wait_for_window .mark .mark.fr1.textno_entry] == "ok"} {
            set textno [.mark.fr1.textno_entry get]
            set mark   [.mark.fr2.mark_entry get]

            if {[kom_text mark $textno $mark]} {
                show_message "Text $textno r nu markerad\n"
                destroy .mark
                return
            } else {
                show_message "Det gick inte att markera $textno.\n"
            }

        } else {
            show_message "Markeringen avbruten!\n"
            destroy .mark
            return
        }
    }
}


# ================================================================
#                          The unmark command


proc unmark_window {w} {
    global romanfont
    global boldfont

    require tkom_windows

    toplevel $w 
    wm title $w "avmarkera text"

    frame $w.fr -relief raised -bd 2
    pack $w.fr -side top -fill both
    label $w.fr.textnolbl -font $boldfont -text "Text nummer:       "
    entry $w.fr.textno_entry -font $romanfont
    pack $w.fr.textnolbl $w.fr.textno_entry -side left

    ok_cancel_buttons $w "Avmarkera"
}


proc unmark_command {{textno {}} } {
    unmark_window .unmark
    if {$textno != ""} {
        .unmark.fr.textno_entry insert end $textno
    }

    while {1} {
        if {[wait_for_window .unmark .unmark.fr.textno_entry] == "ok"} {
            set textno [.unmark.fr.textno_entry get]

            if {[kom_text unmark $textno]} {
                show_message "Text $textno r nu avmarkerad\n"
                destroy .unmark
                return
            } else {
                show_message "Det gick inte att avmarkera $textno.\n"
            }

        } else {
            show_message "Avmarkeringen avbruten!\n"
            destroy .unMARKp
            return
        }
    }
}
