proc main_menu {menuwin} {
    # File menu
    menubutton $menuwin.file -text "Arkiv   " -underline 0 \
	-menu $menuwin.file.m
    menu $menuwin.file.m
    $menuwin.file.m add command -label "Om tkom..." -underline 0 \
	-command {require tkom_commands_file; show_about}
    $menuwin.file.m add separator
    $menuwin.file.m add command -label "Sluta..." \
	-underline 0 -accelerator C-xC-c \
	-command {require tkom_commands_file; tkom_quit}
    pack $menuwin.file -side left

    # Reading menu
    menubutton $menuwin.reading -text "Lsning" -underline 0 \
	-menu $menuwin.reading.m
    menu $menuwin.reading.m
    $menuwin.reading.m add command -label "Lista nyheter" \
	-underline 0 -accelerator ln \
	-command {require tkom_commands_read; show_unread}
    $menuwin.reading.m add command -label "nsta Text" \
	-underline 6 -accelerator nt -command {next_text}
    $menuwin.reading.m add command -label "Hoppa ver alla kommentarer   " \
	-underline 0 -command {not_yet_implemented {Hoppa}} -state disabled
    $menuwin.reading.m add command -label "Nsta mte" \
	-underline 0 -accelerator nm -command {next_conf}
    $menuwin.reading.m add command -label "G till mte..." \
	-underline 0 -accelerator g \
	-command {require tkom_commands_read; goto_conf}
    $menuwin.reading.m add command -label "Endast lsa senaste" \
	-underline 0 -command {not_yet_implemented {Endast lsa senaste}} \
	-state disabled
    $menuwin.reading.m add cascade -label "terse" -underline 0 \
	-menu $menuwin.review_m -accelerator =>
    pack $menuwin.reading -side left

    # Writing menu
    menubutton $menuwin.writing -text "Skrivning" -underline 0 \
	-menu $menuwin.writing.m
    menu $menuwin.writing.m
    $menuwin.writing.m add command -label "Kommentera inlgget    " \
	-underline 0 -accelerator k \
	-command {require tkom_commands_write; comment_text $current_text}
    $menuwin.writing.m add command -label "Fotnot till inlgget" \
	-underline 0 -command {not_yet_implemented {Fotnot}} \
	-state disabled
    $menuwin.writing.m add command -label "Personligt svar" \
	-underline 0 -command {not_yet_implemented {Personligt svar}} \
	-state disabled
    $menuwin.writing.m add command -label "skriva Inlgg" \
	-underline 7  -accelerator i \
 	-command {require tkom_commands_write; write_text}
    $menuwin.writing.m add command -label "skriva Brev" -underline 7 \
	-command {not_yet_implemented {Skriva brev}} -state disabled
    $menuwin.writing.m add command -label "Radera inlgg" -underline 0 \
	-command {not_yet_implemented {Radera inlgg}} -state disabled
    $menuwin.writing.m add command -label "Status inlgg" -underline 0 \
	-command {not_yet_implemented {Status inlgg}} -state disabled
    pack $menuwin.writing -side left

    # Review menu (submenu to the text menu)
    menu $menuwin.review_m
    $menuwin.review_m add command -label "Inlgg" -underline 0 \
	-command {not_yet_implemented {terse inlgg}} \
	-state disabled
    $menuwin.review_m add command -label "det Kommenterade" -underline 4 \
	-command {not_yet_implemented {terse det kommenterade}} \
	-state disabled
    $menuwin.review_m add command -label "kommentarsTrdet" -underline 10 \
	-command {not_yet_implemented {terse Kommentarstrdet}} \
	-state disabled
    $menuwin.review_m add command -label "Alla kommentarer" -underline 0 \
	-command {not_yet_implemented {terse alla kommentarer}} \
	-state disabled
    $menuwin.review_m add command -label "Markerade" -underline 5 \
	-command {not_yet_implemented {terse markerade}} \
	-state disabled
    $menuwin.review_m add command -label "Presentation" -underline 0 \
	-command {not_yet_implemented {terse presentation}} \
	-state disabled

    # Text menu
    menubutton $menuwin.text -text "Inlgg  " -underline 0 \
	-menu $menuwin.text.m
    menu $menuwin.text.m
    $menuwin.text.m add command -label "Addera mottagare" -underline 0 \
	-command {not_yet_implemented {Addera mottagare}} -state disabled 
    $menuwin.text.m add command -label "Addera extra kopiemottagare" \
	-underline 0 -state disabled \
	-command {not_yet_implemented {Addera extra kopiemottagare}}
    $menuwin.text.m add command -label "Subtrahera mottagare" -underline 0 \
	-command {not_yet_implemented {Subtrahera mottagare}} -state disabled 
    $menuwin.text.m add command -label "Addera kommentar" -underline 0 \
	-command {not_yet_implemented {Addera kommentar}} -state disabled 
    $menuwin.text.m add command -label "Subtrahera kommentar" -underline 0 \
	-command {not_yet_implemented {Subtrahera kommentar}} -state disabled 
    $menuwin.text.m add command -label "Markera inlgg" \
	-underline 0 -accelerator M \
        -command {require tkom_commands_text; mark_command $current_text 255}
    $menuwin.text.m add command -label "Avmarkera inlgg" \
	-underline 0 -accelerator A \
        -command {require tkom_commands_text; unmark_command $current_text}
    pack $menuwin.text -side left

    # Person menu
    menubutton $menuwin.person -text "Personer" -underline 0 \
	-menu $menuwin.person.m
    menu $menuwin.person.m
    $menuwin.person.m add command -label "Lista personer" -underline 0 \
	-command {not_yet_implemented {Lista personer}} -state disabled
    $menuwin.person.m add command -label "Status person" -underline 0 \
	-command {not_yet_implemented {Status person}} -state disabled
    $menuwin.person.m add command -label "sKapa person" -underline 1 \
	-command {not_yet_implemented {Skapa person}} -state disabled
    $menuwin.person.m add command -label "Utplna person" -underline 0 \
	-command {not_yet_implemented {Utplna person}} -state disabled
    $menuwin.person.m add command -label "ndra lsenord" -underline 0 \
	-command {not_yet_implemented {ndra lsenord}} \
	-state disabled
    pack $menuwin.person -side left

    # Conference menu
    menubutton $menuwin.conf -text "Mten   " -underline 0 \
	-menu $menuwin.conf.m
    menu $menuwin.conf.m
    $menuwin.conf.m add command -label "Lista mten" -underline 0 \
	-command {not_yet_implemented {Lista mten}} -state disabled
    $menuwin.conf.m add command -label "Bli medlem i mte" \
	-command {not_yet_implemented {Bli medlem i mte}} -state disabled
    $menuwin.conf.m add command -label "Uttrda ur mte" \
	-command {not_yet_implemented {Uttrda ur mte}} -state disabled
    $menuwin.conf.m add command -label "lista Medlemsskap" -underline 6 \
	-command {not_yet_implemented {Lista medlemsskap}} -state disabled
    $menuwin.conf.m add command -label "Status mte" -underline 0 \
	-command {not_yet_implemented {Status mte}} -state disabled
    $menuwin.conf.m add command -label "sKapa mte" -underline 1 \
	-command {not_yet_implemented {Skapa mte}} -state disabled
    $menuwin.conf.m add command -label "Utplna mte" -underline 0 \
	-command {not_yet_implemented {Utplna mte}} -state disabled
    $menuwin.conf.m add command -label "Addera medlem" -underline 0 \
	-command {not_yet_implemented {Addera medlem}} -state disabled 
    $menuwin.conf.m add command -label "Uteslut medlem" -underline 0 \
	-command {not_yet_implemented {Uteslut medlem}} -state disabled 
    $menuwin.conf.m add command -label "ndra namn" -underline 0 \
	-command {not_yet_implemented {ndra namn}} \
	-state disabled
    $menuwin.conf.m add command -label "ndra organisatr" -underline 0 \
	-command {not_yet_implemented {ndra organisatr}} \
	-state disabled
    $menuwin.conf.m add command -label "ndra presentation" -underline 0 \
	-command {not_yet_implemented {ndra presentation}} \
	-state disabled
    $menuwin.conf.m add command -label "ndra livslngd" -underline 0 \
	-command {not_yet_implemented {ndra livslngd}} \
	-state disabled
    $menuwin.conf.m add command -label "ndra supermte" -underline 0 \
	-command {not_yet_implemented {ndra supermte}} \
	-state disabled
    $menuwin.conf.m add command -label "ndra tilltna frfattare" \
	-underline 0 \
	-command {not_yet_implemented {ndra tilltna frfattare}} \
	-state disabled
    $menuwin.conf.m add command -label "Prioritera mte" -underline 0 \
	-command {not_yet_implemented {Prioritera mte}} -state disabled
    pack $menuwin.conf -side left

    # Session menu
    menubutton $menuwin.session -text "sEssion " -underline 1 \
	-menu $menuwin.session.m
    menu $menuwin.session.m
    $menuwin.session.m add command -label "Brja med ny person..." \
	-underline 0 -command {require tkom_commands_session; login}
    $menuwin.session.m add command -label "verg till adminstratrsmod" \
	-underline 0 -command {not_yet_implemented {adm.mode}} -state disabled
    pack $menuwin.session -side left

    # Admin menu
#    menubutton $menuwin.admin -text "Administration" -underline 0 \
#	-menu $menuwin.admin.m
#    menu $menuwin.admin.m
#    $menuwin.admin.m add command -label "" \
#	-underline 0 -command {not_yet_implemented {}}
#    pack $menuwin.admin -side left

    # Misc menu
    menubutton $menuwin.misc -text "Diverse " -underline 0 \
	-menu $menuwin.misc.m
    menu $menuwin.misc.m
    $menuwin.misc.m add command -label "Vilka r inloggade   " \
	-underline 0 -accelerator v -state disabled \
	-command {require tkom_commands_misc; show_logged_in}
    $menuwin.misc.m add command -label "Se tiden" \
	-underline 0 -accelerator t \
	-command {require tkom_commands_misc; display_time}
    $menuwin.misc.m add command -label "F uppmuntran" \
	-underline 0 -accelerator fu \
	-command {require tkom_commands_misc; give_support}
    pack $menuwin.misc -side left

    # Window menu
    menubutton $menuwin.win -text "Fnster " -underline 0 \
	-menu $menuwin.win.m
    menu $menuwin.win.m
    $menuwin.win.m add command -label "Inloggade" -underline 0 \
	-command {not_yet_implemented {Inloggadefnstret}} -state disabled
    $menuwin.win.m add command -label "Olsta inlgg" -underline 0 \
	-command {not_yet_implemented {Olstafnstret}} -state disabled
    pack $menuwin.win -side left

    tk_menuBar $menuwin $menuwin.file $menuwin.reading  $menuwin.writing \
	$menuwin.text $menuwin.person $menuwin.conf $menuwin.session \
	$menuwin.misc $menuwin.win
}


proc elisp-client-bind {w} {
    bind $w <space>                {default_action}
    bind $w <Control-x><Control-c> {require tkom_commands_file; tkom_quit}
    bind $w <l><n>                 {require tkom_commands_read; show_unread}
    bind $w <g>                    {require tkom_commands_read; goto_conf}
    bind $w <n><m>                 {next_conf}
    bind $w <n><t>                 {next_text}
    bind $w <i>                    {require tkom_commands_write; write_text}
    bind $w <k>                    {require tkom_commands_write
				    comment_text $current_text}
    bind $w <f><u>                 {require tkom_commands_misc; give_support}
    bind $w <t>                    {require tkom_commands_misc; display_time}
    bind $w <v>                    {require tkom_commands_misc; show_logged_in}
    bind $w <KeyPress-M>	   {require tkom_commands_text; \
				    mark_command $current_text 255}
    bind $w <KeyPress-A>	   {require tkom_commands_text; \
				    unmark_command $current_text}
}

proc text_text {textwin} {
    global boldfont

    .text tag configure bold -font $boldfont
}

proc main_window {} {
    global romanfont
    global boldfont

    # The menu bar
    frame .menu -relief raised -bd 2
    pack .menu -side top -fill x
    main_menu .menu

    # The status frame
    frame .statf -relief raised -bd 2
    pack .statf -side top -fill x
    label .statf.cur_conf0 -font $boldfont -text "Nrvarande i: "
    label .statf.cur_conf -font $romanfont -text ""
    pack .statf.cur_conf0 .statf.cur_conf -side left

    # The default action frame
    frame .defaultf -relief raised -bd 2
    pack .defaultf -side top -fill x
    label .defaultf.default0 -font $boldfont -text "Kommando:     "
    label .defaultf.default -font $romanfont -text ""
    pack .defaultf.default0 .defaultf.default -side left

    # The message frame, text and scrollbar
    frame .mesgf -relief raised
    pack .mesgf -side bottom -fill x
    scrollbar .mesgf.messagescroll -relief flat -command ".mesgf.message yview"
    pack .mesgf.messagescroll -side right -fill y
    text .mesgf.message -relief raised -bd 2 \
	-height 15 -state disabled \
	-yscrollcommand ".mesgf.messagescroll set" -setgrid true
    pack .mesgf.message -side left -expand TRUE -fill x

    # The text window
    text .text -relief raised -bd 2 -yscrollcommand ".textscroll set" \
	-setgrid true -state disabled
    scrollbar .textscroll -relief flat -command ".text yview"
    pack .text -side left -expand TRUE -fill y
    pack .textscroll -side right -fill y
    text_text .text

    elisp-client-bind .
    wm title . "tkom"
    wm iconname . "tkom"
}


# ================================================================


proc next_text {{default 0}} {
    if {[kom_unread current_conf] == 0} { 
        if {$default} {
            kom_unread goto_next_conf
        } else {
            show_message "Du r inte nrvarande i ngot mte.\n"
        }
    } else {
        read_text .text [kom_unread next_text remove]
    }

    do_things_before_waiting
}


proc next_conf {{default 0}} {
    kom_unread goto_next_conf
    do_things_before_waiting
}


# ================================================================


set tkom_prompt ""

proc show_default_action {} {
    global tkom_prompt

    set tkom_prompt [kom_unread prompt]
    case $tkom_prompt in {
      NEXT_CONF     {.defaultf.default configure -text "G till nsta mte"}
      NEXT_TEXT     {if {[kom_unread current_conf] == 0} { \
                         .defaultf.default configure -text "G till nsta mte"
                     } else {
                         .defaultf.default configure -text "Lsa nsta text"
		     } }
      NEXT_COMMENT  {.defaultf.default configure -text "Lsa nsta kommentar"}
      NEXT_FOOTNOTE {.defaultf.default configure -text "Lsa nsta fotnot"}
      NO_MORE_TEXT  {.defaultf.default configure -text "Se tiden"}
    }
}

proc default_action {} {
    global tkom_prompt
    global to_mark_as_read

    foreach tno $to_mark_as_read {
	kom_text mark_as_read $tno
    }
    set to_mark_as_read {}

    case $tkom_prompt in {
      NEXT_CONF     {next_conf 1}
      NEXT_TEXT     {next_text 1}
      NEXT_COMMENT  {read_text .text [kom_unread next_text remove]}
      NEXT_FOOTNOTE {read_text .text [kom_unread next_text remove]}
      NO_MORE_TEXT  {require tkom_commands_misc; display_time}
    }

    do_things_before_waiting
}


#
# Do necessary things before we wait for the user to do something.
#
proc do_things_before_waiting {} {
    show_current_conf [kom_unread current_conf]
    show_default_action
}


# ================================================================


proc not_yet_implemented {msg} {
    show_message "$msg r nnu inte implementerat.\n"
}


# ================================================================


proc show_message {string} {
    .mesgf.message configure -state normal
    .mesgf.message insert end $string
    .mesgf.message yview -pickplace end
    .mesgf.message configure -state disabled
}


# +++ This is somewhat slow!
# There should be a "kom_unread total_unread_texts" giving the total
# number of unread texts.

proc show_current_conf {confno} {
    if {$confno == -2} then {
        .statf.cur_conf configure -text "Ej uppkopplad mot ngon server"
        return
    } elseif {$confno == -1} then {
        .statf.cur_conf configure -text "Ej inloggad"
        return
    } else {
        if {$confno == 0} {
            set conf_name "Ej nrvarande i ngot mte"
        } else {
            set conf_name [kom_conference name $confno]
        }
        set local_unread 0
        set total_unread 0
        foreach conf [kom_unread unread_texts] {
            set unread [lindex $conf 2]
            if {[lindex $conf 0] == $confno} {
                set local_unread $unread
            }
            incr total_unread $unread
        }
    }
    set text "$conf_name <$local_unread/$total_unread>"
    .statf.cur_conf configure -text $text
}


# ================================================================

proc create_text_tag {textwin textno} {
    global $textwin-tags

    $textwin tag bind  hottext-$textno <Button-1> "show_text $textwin $textno"
    $textwin tag configure hottext-$textno -underline 1
    return hottext-$textno
}

proc delete_text_tags {textwin} {
    foreach tag [$textwin tag names] {
        if [regexp {^hottext-[0-9]+$} $tag] {
            $textwin tag delete $tag
        }
    }
}


proc show_uplink {textwin ulnk} {
    set parent [uplink parent $ulnk]
    set tagname [create_text_tag $textwin $parent]

    $textwin insert end [format "%s till text %d "\
		[expr {[uplink is_footnote $ulnk] ? "Fotnot" : "Kommentar"}]\
                $parent]
    $textwin tag add $tagname {end - 2 char wordstart} {end - 1 char}


    safe_eval {$textwin insert end [format "av %s\n" \
		    [kom_conference name [kom_text author $parent]]]} {
	    {{KOM BADCONF} {$textwin insert end "(Oknd frfattare)\n"}}
	    {{KOM BADTEXT} {$textwin insert end "(Ej lsbar av dig)\n"}}
    }

    if {[uplink sender $ulnk]} {
	safe_eval {$textwin insert end [format " S\{nt av %s\n" \
	                [kom_conference name [uplink sender $ulnk]]]} {
	    {{KOM BADCONF} {$textwin insert end "(Oknd frfattare)\n"}}
	    {{KOM BADTEXT} {$textwin insert end "(Ej lsbar av dig)\n"}}
	}
    }
    if {[uplink sent_later $ulnk]} {
	$textwin insert end [format " S\{nt %s\n" \
	    [format_date [uplink sent_at $ulnk]]]
    }
}


proc show_header {textwin textno} {
    $textwin insert end [format "(%d) %s /%d tecken/ %s\n" \
			$textno \
			[format_date [kom_text ctime $textno]] \
			[kom_text length $textno] \
			[safe_eval \
			    {kom_conference name [kom_text author $textno]} {
			      {{KOM BADCONF} {format "(frfattaren utplnad)"}}
			    }
			]]
    set i 0
    while {$i<[kom_text num_recipients $textno]} {
        $textwin insert end [format_recipient [kom_text recipient $textno $i]]
        incr i 1
    }
    set i 0
    while {$i<[kom_text num_uplinks $textno]} {
        show_uplink $textwin [kom_text uplink $textno $i]
	incr i 1
    }
    if [kom_text num_marks $textno] {
        $textwin insert end [format "Markerad av %d personer\n" \
			[kom_text num_marks $textno]]
    }
}


proc show_footer {textwin textno} {
    set i 0
    while {$i<[kom_text num_footnotes $textno]} {
        show_comment_in $textwin [kom_text footnote $textno $i] "Fotnot"
	incr i 1
    }

    set i 0
    while {$i<[kom_text num_comments $textno]} {
        show_comment_in $textwin [kom_text comment $textno $i] "Kommentar"
	incr i 1
    }
}

proc show_comment_in {textwin textno type} {

    set tagname [create_text_tag $textwin $textno]

    $textwin insert end [format "%s i text %d " $type $textno]
    $textwin tag add $tagname {end - 2 char wordstart} {end - 1 char}

    $textwin insert end \
	[safe_eval {format "av %s\n" \
			[kom_conference name [kom_text author $textno]]} {
	    {{KOM BADCONF} {$textwin insert end "(Oknd frfattare)\n"}}
	    {{KOM BADTEXT} {$textwin insert end "(Ej lsbar av dig)\n"}}}]
    return
}

proc show_text {textwin textno} {
    global delim_pre
    global delim_post
    global current_text

    safe_eval {
	# Check if we are allowed to read the text before doing anything
	# to the window.
	kom_text author $textno 

	$textwin configure -state normal
	$textwin delete 1.0 end
	delete_text_tags $textwin

	show_header $textwin $textno
	#    $textwin insert end [format_header $textno]
	
	$textwin insert end {rende: }
	$textwin tag add bold {end linestart} {end - 1 chars}
	$textwin insert end "[kom_text subject $textno]\n"
	$textwin insert end "$delim_pre\n"
	$textwin insert end "[kom_text body $textno]\n"
	$textwin insert end [format "(%d)%s\n" $textno $delim_post]
	
	show_footer $textwin $textno
	
	$textwin configure -state disabled
	update
	
	set current_text $textno

	# This is an ugly way to do return, since "return" is not allowed
	# within safe_eval.
	format TRUE
    } {
	{{KOM BADTEXT} {show_message "Text $textno r inte lsbar av dig.\n"
	                puts -nonewline "\a"
	                flush stdout
	                return FALSE}}
    }
}


proc read_text {textwin textno} {
    global to_mark_as_read
    
    if {[show_text $textwin $textno]} {
	lappend to_mark_as_read $textno
    } 
}
