provide tkom_windows


# ================================================================
#             Ok and Cancel buttons for a dialog

set windowresult 0

proc ok_cancel_buttons {w {oktext "Ok"} {canceltext "Avbryt"}} {
    button $w.okbutton -text $oktext -command "set windowresult {ok}" \
	-width 12 -pady 2m
    pack $w.okbutton -side left -expand TRUE -anchor center
    button $w.cancbutton -text $canceltext -command "set windowresult cancel" \
	-width 12 -pady 2m
    pack $w.cancbutton -side right -expand TRUE -anchor center
    tkwait visibility $w
}

proc wait_for_window {w {focus 0}} {
    global windowresult

    set oldfocus [focus]
    grab $w
    if {$focus == 0} {
        focus $w
    } else {
        focus $focus
    }

    tkwait variable windowresult
    focus $oldfocus
    return $windowresult
}


# ================================================================
#                     A dialog window


proc dialog_window {w title text} {
    toplevel $w 
    wm title $w $title
    frame $w.top -relief raised -bd 2
    pack $w.top -side top -fill both

    message $w.top.msg -width 3i -font -adobe-times-medium-r-normal-*-180-* \
	-text $text
    pack $w.top.msg -side left -fill both -padx 5m -pady 5m

    ok_cancel_buttons $w
    set result [wait_for_window $w]
    destroy $w

    return $result
}

