source komlib.tcl

connect kom.lysator.liu.se lyskom

set komfile [open [format "komrc" $env(HOME)]]
gets $komfile persno
gets $komfile passwd
login $persno $passwd invisible
set passwd ""

proc www {textno} {
	print_text $textno
}

# Below: overrides with hyperlink info

proc format_uplink {ulnk} {
	set line [format "<a href=%d>" [uplink parent $ulnk]]
	append line [format "%s till text %d av %s\n" \
		[expr {[uplink is_footnote $ulnk] ? "Fotnot" : "Kommentar"}] \
		[uplink parent $ulnk] \
		[conference name [kom_text author [uplink parent $ulnk]]]]
	append line </a>
	if {[uplink sender $ulnk]} {
		append line [format " S\{nt av %s\n" \
			[conference name [uplink sender $ulnk]]]
	}
	if {[uplink sent_later $ulnk]} {
		append line [format " S\{nt %s\n" \
			[format_date [uplink sent_at $ulnk]]]
	}
	return $line
}

proc format_comment_in {textno gurka} {
	format "<a href=%d>%s i text %d av %s</a>\n" $textno $gurka $textno \
		 [conference name [kom_text author $textno]]
}

proc print_text {text_no} {
	global delim_pre delim_post senaste

	puts <pre>
	puts [format_header $text_no]

	puts {[rende: }
	kom_text print_subject $text_no
	puts $delim_pre
	puts </pre>

	kom_text print_body $text_no

	puts <pre>
	puts [format "(%d)%s" $text_no $delim_post]
	puts [format_footer $text_no]
	puts </pre>

	set senaste $text_no
}
